package com.mobisoft.blog.customspeedometer;

import java.util.Random;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;

import com.mobisoft.Utils.SpeedPreference;
import com.mobisoft.view.SpeedometerView;

public class SpeedometerActivity extends Activity {

	private long delay = 10000;

	SpeedometerView mView;

	ImageView arrowImag;

	static Handler handler;

	String result;

	int startAngle;

	String priceStr, speedValueStr;

	Thread threadMainMeter;

	Button changeNeedleValueBtn;

	SpeedPreference speedPreference;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		setContentView(R.layout.speedometer);

		initUI();

		speedPreference = new SpeedPreference(this);

		speedPreference.setPreviousNeedleValue("0");

		moveNeedle();

	}

	private void moveNeedle() {

		handler = new Handler() {

			public void handleMessage(android.os.Message msg) {

				Bundle b = msg.getData();
				int key = b.getInt("angle_in_degrees", 0);

				if (key == 0) {
					
				} else {
					mView.calculateAngleOfDeviation(key);
				}

			};
		};
		handler.postDelayed(null, delay);

		threadMainMeter = new Thread(new Runnable() {

			@Override
			public void run() {

				startAngle = Integer.parseInt(speedPreference
						.getPreviousNeedleValue());

				generateValue();

				if (Integer.parseInt(speedValueStr) > 100) {
					speedValueStr = "100";
				}
				if (startAngle > Integer.parseInt(speedValueStr)) {
					for (int i = startAngle; i >= Integer
							.parseInt(speedValueStr); i = i - 1) {

						try {
							Thread.sleep(15);
							Message msg = new Message();
							Bundle b = new Bundle();
							b.putInt("angle_in_degrees", i);
							msg.setData(b);
							handler.sendMessage(msg);

						} catch (InterruptedException e) {

							e.printStackTrace();
						}
					}

				} else {
					for (int i = startAngle; i <= Integer
							.parseInt(speedValueStr); i = i + 1) {

						try {
							Thread.sleep(15);
							Message msg = new Message();
							Bundle b = new Bundle();
							b.putInt("angle_in_degrees", i);
							msg.setData(b);
							handler.sendMessage(msg);

						} catch (InterruptedException e) {

							e.printStackTrace();
						}
					}
				}
			}
		});

		threadMainMeter.start();

	}

	private void generateValue() {

		Random r = new Random();
		speedValueStr = String.valueOf(r.nextInt(100 - 10) + 10);
		speedPreference.setPreviousNeedleValue(speedValueStr);

	}

	private void initUI() {

		mView = (SpeedometerView) findViewById(R.id.speedometer_view);

		changeNeedleValueBtn = (Button) findViewById(R.id.change_needle_value_btn);
		changeNeedleValueBtn.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				moveNeedle();

			}
		});
	}

	@Override
	public void onPause() {
		super.onPause();

	}

	@Override
	public void onResume() {
		super.onResume();

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.speedometer, menu);
		return true;
	}

}
